Index: res/res_stasis.c
===================================================================
--- res/res_stasis.c	(revision 418809)
+++ res/res_stasis.c	(working copy)
@@ -962,6 +962,19 @@
 	 */
 	cleanup();
 
+	ao2_cleanup(app);
+	app = NULL;
+	control_unlink(control);
+	control = NULL;
+
+	if (!ast_check_hangup_locked(chan) && !ast_channel_pbx(chan)) {
+		struct ast_pbx_args pbx_args = {
+			.no_hangup_chan = 1,
+		};
+
+		res = ast_pbx_run_args(chan, &pbx_args);
+	}
+
 	return res;
 }
 

